<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Algorithm_Longitudinal &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../../_static/doctools.js?v=888ff710"></script>
        <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="Driver" href="driver.html" />
    <link rel="prev" title="Algorithm_Lateral" href="algorithm_lateral.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            openPASS
              <img src="../../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../50_scenario_simulation.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../10_overview.html">Overview</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../20_components.html">Component View</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../20_components.html#components-in-depth">Components in Depth</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="algorithm_lateral.html">Algorithm_Lateral</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Algorithm_Longitudinal</a></li>
<li class="toctree-l4"><a class="reference internal" href="driver.html">Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="dynamics_regular_driving.html">Dynamics_RegularDriving</a></li>
<li class="toctree-l4"><a class="reference internal" href="dynamics_scenario.html">Dynamics_Scenario</a></li>
<li class="toctree-l4"><a class="reference internal" href="sensor_driver.html">Sensor_Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="spawner.html">Spawner</a></li>
<li class="toctree-l4"><a class="reference internal" href="vehicle.html">VehicleComponents</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../50_scenario_simulation.html">Simulator</a></li>
          <li class="breadcrumb-item"><a href="../20_components.html">Component View</a></li>
      <li class="breadcrumb-item active">Algorithm_Longitudinal</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../../_sources/user_guide/sim_user_guide/components/algorithm_longitudinal.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="algorithm-longitudinal">
<span id="id1"></span><h1>Algorithm_Longitudinal<a class="headerlink" href="#algorithm-longitudinal" title="Link to this heading"></a></h1>
<p>This module is responsible for the control of the vehicle’s longitudinal
behavior. It receives the command variables from a driver behavior model and generates
the accelerator and brake pedal position and the current gear of the driver to match
these command variables. The pedal positions and the gear can then be forwarded
to a vehicle dynamics module like <a class="reference internal" href="dynamics_regular_driving.html#dynamics-regular-driving"><span class="std std-ref">Dynamics_RegularDriving</span></a>.
The actuation of the clutch pedal is currently not simulated by the modul</p>
<section id="detailed-description-of-the-module-s-features">
<span id="algorithm-longitudinal-detailed-description"></span><h2>Detailed description of the module’s features<a class="headerlink" href="#detailed-description-of-the-module-s-features" title="Link to this heading"></a></h2>
<section id="inverted-longitudinal-dynamics-model">
<span id="algorithm-longitudinal-detailed-description-inverted-dynamics-model"></span><h3>Inverted longitudinal dynamics model<a class="headerlink" href="#inverted-longitudinal-dynamics-model" title="Link to this heading"></a></h3>
<p>The inverted longitudinal dynamics model produces <img class="math" src="../../../_images/math/af8179e293741ca9978f806f2baba8f661c1865d.png" alt="act_{olc,stat}"/>
by utilizing an inverted powertrain and brake system model. The powertrain model
and all of its parameters and state variables are illustrated in the following image.
The brake model is not worth illustrating, as it directly applies on the required acceleration
<img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/> of the vehicle.</p>
<figure class="align-default" id="id2">
<span id="image-powertrainmodel1"></span><img alt="Illustration of the powertrain model and its parameters and state variables" src="../../../_images/PowertrainModel.svg" /><figcaption>
<p><span class="caption-text">Illustration of the powertrain model and its parameters and state variables</span><a class="headerlink" href="#id2" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>The core element of all calculations in this model is speed and acceleration.
The speed <img class="math" src="../../../_images/math/8a61447e565069614e8fb432e81f2ff844b08063.png" alt="n_{wheel}"/> at the wheels is constraint by the current velocity
<img class="math" src="../../../_images/math/ce393cd126facb28d63240935d17d4978c0fa295.png" alt="v_{act}"/> of the vehicle and the static wheel radius <img class="math" src="../../../_images/math/37e8317b2e01ed1fe34f29869ff8f5d2cdfa78eb.png" alt="r_{stat}"/>:</p>
<div class="math">
<p><img src="../../../_images/math/07fbf754f6d264e88960c917e63746e1f82110ef.png" alt="n_{wheel} = \frac{v_{act}}{r_{stat}} \cdot \frac{60}{2 \cdot \pi}"/></p>
</div><p>where <img class="math" src="../../../_images/math/8a61447e565069614e8fb432e81f2ff844b08063.png" alt="n_{wheel}"/> is specified in <img class="math" src="../../../_images/math/7cd90d08e6307cd6526157e78bb4f46ad2ca5ccd.png" alt="rpm"/> (revolutions per minute) and <img class="math" src="../../../_images/math/ce393cd126facb28d63240935d17d4978c0fa295.png" alt="v_{act}"/> is
defined in <img class="math" src="../../../_images/math/6e9f69ba3f36fefc20991df9c551e1eabdfa961f.png" alt="m/s"/>, which requires the conversion term at the end of the equation.
As the equation also illustrates, only a simple rolling relation defines the
model and there is no simulation of tire-road-friction and tire slip involved.</p>
<p>The speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/> of the engine is constraint by the speed
<img class="math" src="../../../_images/math/8a61447e565069614e8fb432e81f2ff844b08063.png" alt="n_{wheel}"/> of the wheels, the ratio <img class="math" src="../../../_images/math/27e857287a96f2b9a75e247a301de99d8abcbcaf.png" alt="i_{a}"/> of the axle, and the
current ratio <img class="math" src="../../../_images/math/6499be4005808d9b91149ea828b8440f319f93a1.png" alt="i_{g}"/> of the gearbox, depending of the current gear:</p>
<div class="math">
<p><img src="../../../_images/math/7700d757d51c17aef1dc27e32560284623692b49.png" alt="n_{eng} = n_{wheel} \cdot i_{a} \cdot i_{g}"/></p>
</div><p>The required acceleration <img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/> determines the torque <img class="math" src="../../../_images/math/eefe8b4a1faf01734965d041542171e26851e628.png" alt="M_{wheel}"/>
at the wheels, as the overall mass <img class="math" src="../../../_images/math/e9bc7da808d33a16a8347f27a519bd067186aa66.png" alt="m"/> of the vehicle has to be accelerated by
this torque:</p>
<div class="math">
<p><img src="../../../_images/math/835a82c82af32acf5bcbb56bc80601c2e15815a6.png" alt="M_{wheel} = m \cdot a_{set} \cdot r_{stat}"/></p>
</div><p>As the equation illustrates, no driving resistances other than the inertia of
the vehicle are simulated by this model. The required torque <img class="math" src="../../../_images/math/eefe8b4a1faf01734965d041542171e26851e628.png" alt="M_{wheel}"/>
at the wheels must be generated by the engine, considering the ratios of the
powertrain:</p>
<div class="math">
<p><img src="../../../_images/math/b43d532306916773705aed23c7a75a82b8b4cf31.png" alt="M_{eng} = \frac{M_{wheel}}{i_{a} \cdot i_{g}}"/></p>
</div><p>As the current speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/> of the engine, the required acceleration
<img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/> of the vehicle, and the required torque <img class="math" src="../../../_images/math/fb0d511283503b5b3a7208be5b3d6ede3fee25a6.png" alt="M_{eng}"/> of the
engine are known or defined by the above equations, this knowledge can be used
to determine the estimated positions of the accelerator and the brake pedal or
to calculate the optimal gear for the required acceleration <img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/>,
if a positive acceleration is needed. For the accelerator pedal and optimal gear
calculation, there is still some missing knowledge about the engine itself.
The relationship between the current engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/> and the
possible engine torque <img class="math" src="../../../_images/math/fb0d511283503b5b3a7208be5b3d6ede3fee25a6.png" alt="M_{eng}"/> is determined by a simple engine map,
which is illustrated in the following image:</p>
<figure class="align-default" id="id3">
<span id="image-enginemap"></span><img alt="Simplified engine map used for the inverted powertrain model" src="../../../_images/EngineMap.svg" /><figcaption>
<p><span class="caption-text">Simplified engine map used for the inverted powertrain model</span><a class="headerlink" href="#id3" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>The engine map is defined by two characteristic curves:</p>
<ul class="simple">
<li><p><img class="math" src="../../../_images/math/ebc09278ad5cb7f72bfa499d1ac0a95d01089631.png" alt="M_{eng,max}"/> defines the maximum torque, which can be produced by the
engine at a specific engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/>. This is directly connected
with the maximum possible actuation of the accelerator pedal.</p></li>
<li><p><img class="math" src="../../../_images/math/a345dfcfdcfce4c8ae281e87138ed7f269d36b88.png" alt="M_{eng,drag}"/> defines the drag torque, which is produced by the engine
at a specific engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/>, if the accelerator pedal is not
actuated at all.</p></li>
</ul>
<p>The two characteristic curves are only defined between the minimum and maximum
possible speed of the engine. As the two characteristic curves are directly
related to a full actuation (<img class="math" src="../../../_images/math/079743da321af5db6b578a3e4b7cbfecc6dd525a.png" alt="act_{olc,stat} = 1"/>) and no actuation
(<img class="math" src="../../../_images/math/5014405170bcc34e4d69801a016cc42d77684a0c.png" alt="act_{olc,stat} = 0"/>) of the accelerator pedal, the estimated pedal
position for the accelerator pedal <img class="math" src="../../../_images/math/af8179e293741ca9978f806f2baba8f661c1865d.png" alt="act_{olc,stat}"/>, which produces the
currently required engine torque <img class="math" src="../../../_images/math/fb0d511283503b5b3a7208be5b3d6ede3fee25a6.png" alt="M_{eng}"/>, can be calculated by linear
interpolation between these two characteristic curves at the current engine
speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/>.</p>
<p>Analogous for the brake pedal position:</p>
<ul class="simple">
<li><p>The maximum actuation of the brake pedal (<img class="math" src="../../../_images/math/9e8c4d08c11f3f1624eaa41613bfaedd07e86604.png" alt="act_{olc,stat} = -1"/>) is
directly connected with the maximum possible deceleration of the vehicle, which
is simply set to 1G (<img class="math" src="../../../_images/math/2ca7a6569f7c3575a81875a0da7b04ea7dd89990.png" alt="= 9.81 m/s^2"/>).</p></li>
<li><p>No actuation of the brake pedal (<img class="math" src="../../../_images/math/5014405170bcc34e4d69801a016cc42d77684a0c.png" alt="act_{olc,stat} = 0"/>) also produces no
deceleration.</p></li>
</ul>
<p>Between these two possible decelerations, the estimated brake pedal position to
produce the required acceleration <img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/> is calculated by linear
interpolation.</p>
<p>The logic for the calculation of the static controller output <img class="math" src="../../../_images/math/af8179e293741ca9978f806f2baba8f661c1865d.png" alt="act_{olc,stat}"/>,
utilizing the considerations above, is defined as follows:</p>
<p>If the required acceleration <img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/> is smaller than zero, it can be
produced by the engine drag torque or the brake system. If the engine drag
torque <img class="math" src="../../../_images/math/a345dfcfdcfce4c8ae281e87138ed7f269d36b88.png" alt="M_{eng,drag}"/> at the current engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/> is not
strong enough to meet the engine torque <img class="math" src="../../../_images/math/fb0d511283503b5b3a7208be5b3d6ede3fee25a6.png" alt="M_{eng}"/>, which would be
necessary to produce <img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/>, an <strong>additional</strong> actuation of the brake
pedal is applied (the driver does not open the clutch, so the engine drag torque
is also applied to the wheels). This mechanism is not considering a change in
gears, but uses the current gear of the gearbox (the driver does not consider to
shift down for a stronger effect of the engine drag torque).</p>
<p>If the required acceleration <img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/> is greater than or equal to zero,
it can only be produced by the powertrain. First of all, the optimal gear to
produce the engine torque <img class="math" src="../../../_images/math/fb0d511283503b5b3a7208be5b3d6ede3fee25a6.png" alt="M_{eng}"/> required for <img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/> is
calculated, which is described in <a class="reference internal" href="#algorithm-longitudinal-openloop-optimal-gear"><span class="std std-ref">the subsequent subsection</span></a>.
With this chosen gear, the current engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/> is calculated.
<img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/> is used to determine the maximum engine torque <img class="math" src="../../../_images/math/ebc09278ad5cb7f72bfa499d1ac0a95d01089631.png" alt="M_{eng,max}"/>
and the engine drag torque <img class="math" src="../../../_images/math/a345dfcfdcfce4c8ae281e87138ed7f269d36b88.png" alt="M_{eng,drag}"/> from the characteristic curves.
As these two values are connected to a full actuation and no actuation of the
accelerator pedal, the estimated accelerator pedal position, which is necessary
to produce the required acceleration <img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/>, can be calculated by
linear interpolation.</p>
<p>The state variable <img class="math" src="../../../_images/math/ce393cd126facb28d63240935d17d4978c0fa295.png" alt="v_{act}"/> is received from the module <a class="reference internal" href="sensor_driver.html#sensor-driver"><span class="std std-ref">Sensor_Driver</span></a>,
the required acceleration <img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/> is received from a driver behavior
model, and the vehicle parameters <img class="math" src="../../../_images/math/e9bc7da808d33a16a8347f27a519bd067186aa66.png" alt="m"/>, <img class="math" src="../../../_images/math/37e8317b2e01ed1fe34f29869ff8f5d2cdfa78eb.png" alt="r_{stat}"/>, <img class="math" src="../../../_images/math/27e857287a96f2b9a75e247a301de99d8abcbcaf.png" alt="i_{a}"/>, <img class="math" src="../../../_images/math/6499be4005808d9b91149ea828b8440f319f93a1.png" alt="i_{g}"/> per gear,
and the information about the engine map are received from the module <a class="reference internal" href="../../../advanced_topics/simulator/agent_components.html#parameters-vehicle"><span class="std std-ref">Parameters_Vehicle</span></a>.</p>
<p>The calculations above are done in the function CalculatePedalPositions, which is called in
the function CalculatePedalPositionAndGear of Algorithm_Longitudinal.</p>
</section>
<section id="algorithm-for-optimal-gear-determination">
<span id="algorithm-longitudinal-openloop-optimal-gear"></span><h3>Algorithm for optimal gear determination<a class="headerlink" href="#algorithm-for-optimal-gear-determination" title="Link to this heading"></a></h3>
<p>The algorithm for the determination of the optimal gear for the required
acceleration <img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/> is implemented in the function CalculateGearAndEngineSpeed.
It is called within the function CalculatePedalPositionAndGear of Algorithm_Longitudinal,
which applies the <a class="reference internal" href="#algorithm-longitudinal-detailed-description-inverted-dynamics-model"><span class="std std-ref">inverted longitudinal dynamics model</span></a>.
The algorithm receives the current velocity <img class="math" src="../../../_images/math/ce393cd126facb28d63240935d17d4978c0fa295.png" alt="v_{act}"/> of the vehicle and the required acceleration <img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/>.</p>
<p>Within a for-loop over all gears, the engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/> is calculated
for each gear, which would result from the current velocity <img class="math" src="../../../_images/math/ce393cd126facb28d63240935d17d4978c0fa295.png" alt="v_{act}"/>,
as well as the maximum engine torque <img class="math" src="../../../_images/math/ebc09278ad5cb7f72bfa499d1ac0a95d01089631.png" alt="M_{eng,max}"/> and the engine drag
torque <img class="math" src="../../../_images/math/a345dfcfdcfce4c8ae281e87138ed7f269d36b88.png" alt="M_{eng,drag}"/> resulting from these engine speeds. Violating the
minimum engine speed <img class="math" src="../../../_images/math/d84bc4f13818666efe972485ffa26ce9163877a0.png" alt="n_{eng,min}"/> and the maximum engine speed <img class="math" src="../../../_images/math/de3b7384cfeaffe57a5f76636b9bb260f64cc2ad.png" alt="n_{eng,max}"/>
is not considered in this step (resulting engine speeds are written as they result
from the powertrain calculation and the engine torques are set to the lower or
upper limits of the characteristic curves respectively, if the engine speed
range is violated).</p>
<p>The results above are further processed in a second for-loop over all gears.
The following aspects are checked to determine, if a gear fits the current
required state:</p>
<ul class="simple">
<li><p>Is the resulting engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/> within the range of <img class="math" src="../../../_images/math/d84bc4f13818666efe972485ffa26ce9163877a0.png" alt="n_{eng,min}"/>
and <img class="math" src="../../../_images/math/de3b7384cfeaffe57a5f76636b9bb260f64cc2ad.png" alt="n_{eng,max}"/>?</p></li>
<li><p>Is the resulting engine torque <img class="math" src="../../../_images/math/fb0d511283503b5b3a7208be5b3d6ede3fee25a6.png" alt="M_{eng}"/> to produce the required
acceleration <img class="math" src="../../../_images/math/e61db86029a965d003355f05934bacdb7fe5fd45.png" alt="a_{set}"/> within the range of <img class="math" src="../../../_images/math/a345dfcfdcfce4c8ae281e87138ed7f269d36b88.png" alt="M_{eng,drag}"/> and <img class="math" src="../../../_images/math/ebc09278ad5cb7f72bfa499d1ac0a95d01089631.png" alt="M_{eng,max}"/>?</p></li>
</ul>
<p>The lowest gear that fits these criteria sets a Boolean foundGear true and the
results (gear number and resulting engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/>) are written in
the result vector. This is done for all further gears, until a gear does not fit
the requirements anymore. This initiates the return of the last sufficient gear
and its resulting engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/>. A short example should
illustrate this logic:</p>
<ol class="arabic simple">
<li><p>The 2nd gear activates the Boolean foundGear, because <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/> does
not exceed <img class="math" src="../../../_images/math/de3b7384cfeaffe57a5f76636b9bb260f64cc2ad.png" alt="n_{eng,max}"/> anymore</p></li>
<li><p>The 4th gear activates the return of the results, because the required engine
torque <img class="math" src="../../../_images/math/fb0d511283503b5b3a7208be5b3d6ede3fee25a6.png" alt="M_{eng}"/> would exceed the maximum possible engine torque <img class="math" src="../../../_images/math/ebc09278ad5cb7f72bfa499d1ac0a95d01089631.png" alt="M_{eng,max}"/>
at the corresponding engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/></p></li>
<li><p>The algorithm chooses the 3rd gear as optimum and returns it and its
corresponding engine speed <img class="math" src="../../../_images/math/7488c00111382f5f04d931d6f3ecb4435438ffad.png" alt="n_{eng}"/></p></li>
</ol>
<p>This logic therefore guarantees, that always the highest possible gear is chosen
by the driver.</p>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="algorithm_lateral.html" class="btn btn-neutral float-left" title="Algorithm_Lateral" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="driver.html" class="btn btn-neutral float-right" title="Driver" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>